poj 2187 凸包or旋转qia壳法

2024-09-09 16:08
文章标签 旋转 poj 2187 凸包 qia 壳法

本文主要是介绍poj 2187 凸包or旋转qia壳法,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题意:

给n(50000)个点,求这些点与点之间距离最大的距离。


解析:

先求凸包然后暴力。

或者旋转卡壳大法。


代码:

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>
#include <cmath>
#include <stack>
#include <vector>
#include <queue>
#include <map>
#include <climits>
#include <cassert>
#define LL long longusing namespace std;
const int inf = 0x3f3f3f3f;
const double eps = 1e-8;
const double pi = acos(-1.0);
const double ee = exp(1.0);/
struct Point
{double x, y;Point(double x = 0, double y = 0) : x(x), y(y) {}
};bool cmp(Point A, Point B)
{if (A.x == B.x)return A.y < B.y;return A.x < B.x;
}typedef Point Vector;Vector operator + (Vector A, Vector B)
{return Vector(A.x + B.x, A.y + B.y);
}Vector operator - (Point A, Point B)
{return Vector(A.x - B.x, A.y - B.y);
}Vector operator * (Vector A, double p)
{return Vector(A.x * p, A.y * p);
}Vector operator / (Vector A, double p)
{return Vector(A.x / p, A.y / p);
}//便于点排序
bool operator < (const Point& a, const Point& b)
{return a.x < b.x || (a.x == b.x && a.y < b.y);
}//用于判断相等
int dcmp(double x)
{if (fabs(x) < eps){return 0;}else{return x < 0 ? -1 : 1;}
}bool operator == (const Point& a, const Point& b)
{return dcmp(a.x - b.x) == 0 && dcmp(a.y - b.y) == 0;
}//点积
double Dot(Vector A, Vector B)
{return A.x * B.x + A.y * B.y;
}//向量长度
double Length(Vector A)
{return sqrt(Dot(A, A));
}//向量夹角
double Angle(Vector A, Vector B)
{return acos(Dot(A, B) / Length(A) / Length(B));
}//叉集
double Cross(Vector A, Vector B)
{return A.x * B.y - A.y * B.x;
}//求两个向量相夹的面积
double Area2(Point A, Point B, Point C)
{return Cross(B - A, C - A);
}//旋转rad弧度
Vector Rotate(Vector A, double rad)
{return Vector(A.x * cos(rad) - A.y * sin(rad), A.x * sin(rad) + A.y * cos(rad));
}//向量的单位法线即向量左转90°
Vector Normal(Vector A)
{double L = Length(A);return Vector(-A.y / L, A.x / L);
}//求交点坐标
Point GetLineIntersection(Point P, Vector v, Point Q, Vector w)
{Vector u = P - Q;double t = Cross(w, u) / Cross(v, w);return P + v * t;
}//点P到直线AB的距离
double DistanceToLine(Point P, Point A, Point B)
{Vector v1 = B - A;Vector v2 = P - A;return fabs(Cross(v1, v2)) / Length(v1);
}//点到直线的距离
double DistanceToSegment(Point P, Point A, Point B)
{if (A == B){return Length(P - A);}Vector v1 = B - A;Vector v2 = P - A;Vector v3 = P - B;if (dcmp(Dot(v1, v2)) < 0)return Length(v2);else if (dcmp(Dot(v1, v3)) > 0)return Length(v3);elsereturn fabs(Cross(v1, v2)) / Length(v1);
}//判断线段是否相交
bool SegmentProperIntersection(Point a1, Point a2, Point b1, Point b2)
{double c1 = Cross(a2 - a1, b1 - a1), c2 = Cross(a2 - a1, b2 - a1);double c3 = Cross(b2 - b1, a1 - b1), c4 = Cross(b2 - b1, a2 - b1);return dcmp(c1) * dcmp(c2) < 0 && dcmp(c3) * dcmp(c4) < 0;
}//线段是否在端点相交 + 线段相交的判定
bool OnSegment(Point p, Point a1, Point a2)
{return dcmp(Cross(a1 - p, a2 - p)) == 0 && dcmp(Dot(a1 - p, a2 - p)) < 0;
}//传入顶点集 计算多边形的面积
double ConvexPolygonArea(Point* p, int n)
{double area = 0;for (int i = 1; i < n - 1; i++){area += Cross(p[i] - p[0], p[i + 1] - p[0]);}return area / 2.0;
}//° -> 弧度
double torad(double deg)
{return deg / 180 * pi;
}//求凸包 返回点个数 ch为凸包的点
int ConvexHull(Point* p, int n, Point* ch)
{sort(p, p + n);int m = 0;for (int i = 0; i < n; i++){while (m > 1 && Cross(ch[m - 1] - ch[m - 2], p[i] - ch[m - 2]) <= 0)m--;ch[m++] = p[i];}int k = m;for (int i = n - 2; i >= 0; i--){while (m > k && Cross(ch[m - 1] - ch[m - 2], p[i] - ch[m - 2]) <= 0)m--;ch[m++] = p[i];}if (n > 1)m--;return m;
}Point readPoint()
{double x, y;scanf("%lf %lf", &x, &y);return Point(x, y);
}//
const int maxn = 50000 + 10;int n;
Point p[maxn << 1];
Point ch[maxn << 1];double dist(Point a, Point b)
{return Dot(a - b, a - b);
}void bruteForce()
{double ans = 0;int m = ConvexHull(p, n, ch);for (int i = 0; i < m; i++){for (int j = i + 1; j < m; j++){ans = max(ans, dist(ch[i], ch[j]));}}printf("%.0lf\n", ans);
}void rotatingCalipers()
{double ans = 0;int m = ConvexHull(p, n, ch);if (m == 2){printf("%.0lf\n", dist(ch[0], ch[1]));return;}int i = 0, j = 0;for (int k = 0; k < m; k++){if (ch[k] < ch[i])i = k;if (ch[j] < ch[k])j = k;}int si = i, sj = j;while (i != sj || j != si){ans = max(ans, dist(ch[i], ch[j]));if (Cross(ch[(i + 1) % m] - ch[i], ch[(j + 1) % m] - ch[j]) < 0){i = (i + 1) % m;}else{j = (j + 1) % m;}}printf("%.0lf\n", ans);
}int main()
{
#ifdef LOCALfreopen("in.txt", "r", stdin);
#endif // LOCALwhile (~scanf("%d", &n)){for (int i = 0; i < n; i++){p[i] = readPoint();}rotatingCalipers();}return 0;
}


这篇关于poj 2187 凸包or旋转qia壳法的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1151639

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i